'*************************************************************************
' Klass: frmCDDVDLabel
' Beroenden: 
' Syfte: 
' F�rfattare: Fredrik Haglund, Stefan Haglund
' Senast �ndrad av: Stefan Haglund
' Senast �ndrad: 2007-04-24 20:03
' Kommentarer: 
'*************************************************************************

Imports System.Threading
Imports System.Globalization
Imports System.Resources
Imports CDBurnerXP.Controls

Public Class frmCDDVDLabel
  Private m_LayoutManager As FileLayoutManager

  <CLSCompliant(False)> Public Sub New(ByVal layoutManager As FileLayoutManager)
    MyBase.New()
    'This call is required by the Windows Form Designer.
    InitializeComponent()

    AcceptButton = cmdSetLabels
    CancelButton = cmdCancel
    m_LayoutManager = layoutManager
  End Sub

  Private Sub frmLabel_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
    Me.Text = RM.GetString("Set ISO Volume Labels")
    lblCreationDate.Text = RM.GetString("Creation Date:")
    lblLastModified.Text = RM.GetString("Last Modified:")
    lblExpiration.Text = RM.GetString("Expiration Date:")
    lblEffectiveTime.Text = RM.GetString("Effective Time:")
    lblVolumeLabel.Text = RM.GetString("Disc name:")
    lblSystemIdentifier.Text = RM.GetString("System Identifier:")
    lblVolumeSet.Text = RM.GetString("Volume Set:")
    lblPublisher.Text = RM.GetString("Publisher:")
    lblDataPreparer.Text = RM.GetString("Data Preparer:")
    lblApplication.Text = RM.GetString("Application:")
    lblCopyrightFile.Text = RM.GetString("Copyright File:")
    lblAbstractFile.Text = RM.GetString("Abstract File:")
    lblBibliographicFile.Text = RM.GetString("Bibliographic File:")
    cmdSetLabels.Text = RM.GetString("OK")
    cmdCancel.Text = RM.GetString("Cancel")

    SetLabelStatus()
  End Sub

  Private Sub SetLabelStatus()
    Dim createdate As Date = m_LayoutManager.DataImage.GetVolumeInfo().CreationDateTime()
    Dim modifieddate As Date = m_LayoutManager.DataImage.GetVolumeInfo().ModificationDateTime()
    Dim expirationdate As Date = m_LayoutManager.DataImage.GetVolumeInfo().ExpirationDateTime()
    Dim effectivetime As Date = m_LayoutManager.DataImage.GetVolumeInfo().EffectiveDateTime()

    txtVolumeLabel.Text = m_LayoutManager.DataImage.GetVolumeInfo().VolumeID()
    txtSystemIdentifier.Text = m_LayoutManager.DataImage.GetVolumeInfo().SystemID().Trim.ToUpper
    txtVolumeSet.Text = m_LayoutManager.DataImage.GetVolumeInfo().VolumeSetID().Trim.ToUpper
    txtPublisher.Text = m_LayoutManager.DataImage.GetVolumeInfo().PublisherID().Trim.ToUpper
    txtDataPreparer.Text = m_LayoutManager.DataImage.GetVolumeInfo().DataPreparerID().Trim.ToUpper

    txtApplication.Text = m_LayoutManager.DataImage.GetVolumeInfo().ApplicationID
    txtCopyrightFile.Text = m_LayoutManager.DataImage.GetVolumeInfo().CopyrightFile().Trim.ToUpper
    txtAbstractFile.Text = m_LayoutManager.DataImage.GetVolumeInfo().AbstractFile().Trim.ToUpper
    txtBibliographicFile.Text = m_LayoutManager.DataImage.GetVolumeInfo().BiblioFile().Trim.ToUpper

    If createdate <> Nothing Then
      dtpCreationDate.Value = createdate
    Else
      dtpCreationDate.Value = Date.Now()
    End If

    If modifieddate <> Nothing Then
      dtpModifiedDate.Value = modifieddate
    Else
      dtpModifiedDate.Value = Date.Now()
    End If

    If expirationdate <> Nothing Then
      dtpExpirationDate.Value = expirationdate
    Else
      dtpExpirationDate.Value = Date.Now()
    End If

    If effectivetime <> Nothing Then
      dtpEffectiveDate.Value = effectivetime
    Else
      dtpEffectiveDate.Value = Date.Now()
    End If
  End Sub

  Private Sub cmdSetLabels_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSetLabels.Click
    m_LayoutManager.LayoutName = txtVolumeLabel.Text.Trim
    m_LayoutManager.DataImage.GetVolumeInfo().SystemID = txtSystemIdentifier.Text.Trim.ToUpper
    m_LayoutManager.DataImage.GetVolumeInfo().VolumeSetID = txtVolumeSet.Text.Trim.ToUpper
    m_LayoutManager.DataImage.GetVolumeInfo().PublisherID = txtPublisher.Text.Trim.ToUpper
    m_LayoutManager.DataImage.GetVolumeInfo().DataPreparerID = txtDataPreparer.Text.Trim
    m_LayoutManager.DataImage.GetVolumeInfo().ApplicationID = txtApplication.Text.Trim
    m_LayoutManager.DataImage.GetVolumeInfo().CopyrightFile = txtCopyrightFile.Text.Trim.ToUpper
    m_LayoutManager.DataImage.GetVolumeInfo().AbstractFile = txtAbstractFile.Text.Trim.ToUpper
    m_LayoutManager.DataImage.GetVolumeInfo().BiblioFile = txtBibliographicFile.Text.Trim.ToUpper
    m_LayoutManager.DataImage.GetVolumeInfo().CreationDateTime = dtpCreationDate.Value
    m_LayoutManager.DataImage.GetVolumeInfo().ModificationDateTime = dtpModifiedDate.Value
    m_LayoutManager.DataImage.GetVolumeInfo().ExpirationDateTime = dtpExpirationDate.Value
    m_LayoutManager.DataImage.GetVolumeInfo().EffectiveDateTime = dtpEffectiveDate.Value
    Me.Close()
  End Sub

  Private Sub cmdCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCancel.Click
    Me.Close()
  End Sub

End Class
