'*************************************************************************
' Klass: frmCDDVDSelectDropFolder
' Beroenden: 
' Syfte: 
' F�rfattare: Fredrik Haglund, Stefan Haglund
' Senast �ndrad av: Stefan Haglund
' Senast �ndrad: 2007-04-24 20:0�9
' Kommentarer: 
'*************************************************************************

Imports System.Threading
Imports System.Globalization
Imports System.Resources
Imports CDBurnerXP.Controls

Public Class frmCDDVDSelectDropFolder
  Private tmpTreeView As TreeView
  Private _SelectedNode As TreeNode

  Public Sub New(ByVal TVW As TreeView)
    ' This call is required by the Windows Form Designer.
    InitializeComponent()

    tmpTreeView = TVW
  End Sub

  Public ReadOnly Property SelectedNode() As TreeNode
    Get
      Return _SelectedNode
    End Get
  End Property

  Private Sub frmCDDVDSelectDropFolder_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
    'LanguageSet
    Me.Text = RM.GetString("Select Drop Folder")
    cmdSelect.Text = RM.GetString("Select")
    cmdCancel.Text = RM.GetString("Cancel")
    tvwDropFolder.ImageList = FileLayoutManager.FileIcons
    tvwDropFolder.BeginUpdate()
    Dim rootNode As New TreeNode
    rootNode.ImageKey = "?Root"
    rootNode.SelectedImageKey = "?Root"
    rootNode.Text = RM.GetString("Root")
    tvwDropFolder.Nodes.Add(rootNode)

    RecurseNodesAddMenu(rootNode.Nodes, tmpTreeView.Nodes(0).Nodes)
    tvwDropFolder.EndUpdate()
    tvwDropFolder.Nodes(0).Expand()
    tvwDropFolder.SelectedNode = tvwDropFolder.Nodes(0)
  End Sub

  Private Sub RecurseNodesAddMenu(ByRef orgNodes As TreeNodeCollection, ByRef cNodes As TreeNodeCollection)

    For Each tNode As TreeNode In cNodes
      Dim tmpnode As New TreeNode
      tmpnode.ImageKey = tNode.ImageKey
      tmpnode.SelectedImageKey = tNode.SelectedImageKey
      tmpnode.Tag = tNode.Tag
      tmpnode.Text = tNode.Text
      orgNodes.Add(tmpnode)

      RecurseNodesAddMenu(tmpnode.Nodes, tNode.Nodes)
    Next
  End Sub

  Private Sub cmdSelect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSelect.Click
    _SelectedNode = tvwDropFolder.SelectedNode
    Me.Close()
  End Sub

  Private Sub cmdCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCancel.Click
    _SelectedNode = Nothing
    Me.Close()
  End Sub

  Private Sub tvwDropFolder_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles tvwDropFolder.MouseDown
    If e.Button = Windows.Forms.MouseButtons.Left AndAlso e.Clicks = 2 Then
      If tvwDropFolder.GetNodeAt(e.X, e.Y) Is Nothing Then
        Exit Sub
      Else
        _SelectedNode = tvwDropFolder.GetNodeAt(e.X, e.Y)
        Me.Close()
      End If
    End If
  End Sub
End Class
