'*************************************************************************
' Klass: frmAbout
' Beroenden: 
' Syfte: 
' F�rfattare: Fredrik Haglund, Stefan Haglund
' Senast �ndrad av: Stefan Haglund
' Senast �ndrad: 2007-04-25 20:35
' Kommentarer: 
'*************************************************************************

Imports System.Threading
Imports System.Globalization
Imports System.Resources
Imports System.Text

Public Class frmAbout
  Private m_CustomOverlay As Bitmap
  Private m_CustomLink As String

  Protected Overrides ReadOnly Property AutoMirrorEnabled() As Boolean
    Get
      Return False
    End Get
  End Property

  Public Sub New()
    ' This call is required by the Windows Form Designer.
    InitializeComponent()
    CancelButton = cmdClose

    ' Add any initialization after the InitializeComponent() call.
    ExceptionButton()
  End Sub

  <Conditional("DEBUG")> _
  Private Sub ExceptionButton()
    btnError.Visible = True
  End Sub

  Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
    MyBase.OnLoad(e)

    Dim customPath As String = Application.StartupPath & "\custom.link.txt"
    If System.IO.File.Exists(customPath) Then
      Dim contents As String = System.IO.File.ReadAllText(customPath)
      Dim data As String() = contents.Split("|"c)
      If data.Length = 2 Then
        llCustom.Text = data(1)
        llCustom.Visible = True
        m_CustomLink = data(0)
      End If
    End If

    Me.Text = RM.GetString("About")
    cmdClose.Text = RM.GetString("Close")
    Me.lblCopyright.Text = "© 2002-" & DateTime.Now.Year.ToString() & " Canneverbe Limited"
    Me.lblCopyright.AccessibleDescription = Me.lblCopyright.Text
    lblVersion.Text = Application.ProductVersion
    lblVersion.AccessibleDescription = Application.ProductVersion
    CDBScroller.SpecialThanks = RM.GetString("Special Thanks")
    CDBScroller.ForeColor = Color.White
    CDBScroller.CDBXPTeam = RM.GetString("CDBurnerXP Team")
    CDBScroller.Translators = RM.GetString("Translators")
    CDBScroller.Contributors = RM.GetString("Contributors")
    CDBScroller.Parent = Me
    CDBScroller.StartScroll()
  End Sub

  Private Sub cmdClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdClose.Click
    Me.Close()
  End Sub

  Protected Overrides Sub OnPaintBackground(ByVal e As System.Windows.Forms.PaintEventArgs)
    MyBase.OnPaintBackground(e)

    ' Possibly load customised images
    Dim imgPath As String = Application.StartupPath + "\custom.about.png"
    If m_CustomOverlay Is Nothing And System.IO.File.Exists(imgPath) Then
      Try
        m_CustomOverlay = CType(Bitmap.FromFile(imgPath), Bitmap)
      Catch
      End Try
    End If

    If Not m_CustomOverlay Is Nothing Then
      e.Graphics.DrawImageUnscaled(m_CustomOverlay, New Point(0, 0))
    End If
  End Sub

  Private Sub btnError_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnError.Click
    Dim f As frmErrorReport = New frmErrorReport(New SystemException(Me.Text))
    f.ShowDialog(Me)
  End Sub

  Private Sub frmAbout_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
    If Not m_CustomOverlay Is Nothing Then m_CustomOverlay.Dispose()
  End Sub

  Private Sub llCustom_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles llCustom.LinkClicked
    Try
      System.Diagnostics.Process.Start(m_CustomLink)
    Catch
    End Try
  End Sub
End Class
