'*************************************************************************
' Klass: frmRecorderInfo
' Beroenden: 
' Syfte: 
' F�rfattare: Fredrik Haglund, Stefan Haglund
' Senast �ndrad av: Stefan Haglund
' Senast �ndrad: 2007-04-26 08:49
' Kommentarer: 
'*************************************************************************

Imports System.IO
Imports System.Threading
Imports System.Globalization
Imports System.Resources
Imports CDBurnerXP.IO
Imports System.Text

Public Class frmRecorderInfo
  Private oDevice As NMSDVDXLib.DeviceX
  Private DriveCaps(68) As DriveCap

  Protected Overrides ReadOnly Property AutoTranslate() As Boolean
    Get
      Return True
    End Get
  End Property

  Private Enum Feature
    Read = 1
    Write = 2
    Misc = 3
  End Enum

  Private Structure DriveCap
    Dim Name As String
    Dim Value As Integer
    Dim Feat As Feature
  End Structure

  <CLSCompliant(False)> Public Sub New(ByRef oDeviceX As NMSDVDXLib.DeviceX)
    MyBase.New()

    'This call is required by the Windows Form Designer.
    Init()
    InitializeComponent()
    ' thanks M$ for deleting my settings!
    Me.CancelButton = cmdClose

    'Add any initialization after the InitializeComponent() call
    oDevice = oDeviceX
    If Not oDevice Is Nothing Then
      oDevice.Refresh(True)
      cboDrive.SelectedDevice = oDevice
    End If
  End Sub

  Private Sub Init()
    'Reading features
    Dim s_Reads As String = RM.GetString("Reads")
    Dim s_Writes As String = RM.GetString("Writes")
    DriveCaps(0).Name = s_Reads & " " & "CD-R"
    DriveCaps(0).Value = 0
    DriveCaps(0).Feat = Feature.Read
    DriveCaps(1).Name = s_Reads & " " & "CD-RW"
    DriveCaps(1).Value = 1
    DriveCaps(1).Feat = Feature.Read
    DriveCaps(2).Name = s_Reads & " " & "DVD ROM"
    DriveCaps(2).Value = 2
    DriveCaps(2).Feat = Feature.Read
    DriveCaps(3).Name = s_Reads & " " & "DVD-R"
    DriveCaps(3).Value = 3
    DriveCaps(3).Feat = Feature.Read
    DriveCaps(4).Name = s_Reads & " " & "DVD-RW"
    DriveCaps(4).Value = 4
    DriveCaps(4).Feat = Feature.Read
    DriveCaps(5).Name = s_Reads & " " & "DVD-R Dual Layer"
    DriveCaps(5).Value = 5
    DriveCaps(5).Feat = Feature.Read
    DriveCaps(6).Name = s_Reads & " " & "DVD-Ram"
    DriveCaps(6).Value = 6
    DriveCaps(6).Feat = Feature.Read
    DriveCaps(7).Name = s_Reads & " " & "DVD+RW"
    DriveCaps(7).Value = 7
    DriveCaps(7).Feat = Feature.Read
    DriveCaps(8).Name = s_Reads & " " & "DVD+R"
    DriveCaps(8).Value = 8
    DriveCaps(8).Feat = Feature.Read
    DriveCaps(9).Name = s_Reads & " " & "DVD+R Dual Layer"
    DriveCaps(9).Value = 9
    DriveCaps(9).Feat = Feature.Read
    DriveCaps(10).Name = s_Reads & " " & "Blu-Ray (BD-R)"
    DriveCaps(10).Value = 10
    DriveCaps(10).Feat = Feature.Read
    DriveCaps(11).Name = s_Reads & " " & "Blu-Ray (BD-ROM)"
    DriveCaps(11).Value = 11
    DriveCaps(11).Feat = Feature.Read
    DriveCaps(12).Name = s_Reads & " " & "Blu-Ray (BD-RE)"
    DriveCaps(12).Value = 12
    DriveCaps(12).Feat = Feature.Read
    DriveCaps(13).Name = s_Reads & " " & "HD DVD-R)"
    DriveCaps(13).Value = 13
    DriveCaps(13).Feat = Feature.Read
    DriveCaps(14).Name = s_Reads & " " & "HD DVD-ROM"
    DriveCaps(14).Value = 14
    DriveCaps(14).Feat = Feature.Read
    DriveCaps(15).Name = s_Reads & " " & "HD DVD-RAM"
    DriveCaps(15).Value = 15
    DriveCaps(15).Feat = Feature.Read
    DriveCaps(31).Name = s_Reads & " " & "Mode2 Form1"
    DriveCaps(31).Value = 31
    DriveCaps(31).Feat = Feature.Read
    DriveCaps(32).Name = s_Reads & " " & "Mode2 Form2"
    DriveCaps(32).Value = 32
    DriveCaps(32).Feat = Feature.Read
    DriveCaps(33).Name = RM.GetString("Reads MultiSession")
    DriveCaps(33).Value = 33
    DriveCaps(33).Feat = Feature.Read
    DriveCaps(34).Name = s_Reads & " " & "FP Method2"
    DriveCaps(34).Value = 34
    DriveCaps(34).Feat = Feature.Read
    DriveCaps(35).Name = s_Reads & " " & "RW"
    DriveCaps(35).Value = 35
    DriveCaps(35).Feat = Feature.Read
    DriveCaps(36).Name = s_Reads & " " & "ISRC"
    DriveCaps(36).Value = 36
    DriveCaps(36).Feat = Feature.Read
    DriveCaps(37).Name = s_Reads & " " & "UPC"
    DriveCaps(37).Value = 37
    DriveCaps(37).Feat = Feature.Read
    DriveCaps(38).Name = RM.GetString("Reads BarCode")
    DriveCaps(38).Value = 38
    DriveCaps(38).Feat = Feature.Read
    DriveCaps(39).Name = s_Reads & " " & "RW SubDeint"
    DriveCaps(39).Value = 39
    DriveCaps(39).Feat = Feature.Read
    DriveCaps(40).Name = s_Reads & " " & "PW LeadIn"
    DriveCaps(40).Value = 40
    DriveCaps(40).Feat = Feature.Read
    DriveCaps(68).Name = s_Reads & " " & "CD Text"
    DriveCaps(68).Value = 68
    DriveCaps(68).Feat = Feature.Read

    'Writing features
    DriveCaps(16).Name = s_Writes & " " & "CD-R"
    DriveCaps(16).Value = 16
    DriveCaps(16).Feat = Feature.Write
    DriveCaps(17).Name = s_Writes & " " & "CD-RW"
    DriveCaps(17).Value = 17
    DriveCaps(17).Feat = Feature.Write
    DriveCaps(18).Name = s_Writes & " " & "DVD-R"
    DriveCaps(18).Value = 18
    DriveCaps(18).Feat = Feature.Write
    DriveCaps(19).Name = s_Writes & " " & "DVD-RW"
    DriveCaps(19).Value = 19
    DriveCaps(19).Feat = Feature.Write
    DriveCaps(20).Name = s_Writes & " " & "DVD-R Dual Layer"
    DriveCaps(20).Value = 20
    DriveCaps(20).Feat = Feature.Write
    DriveCaps(21).Name = s_Writes & " " & "DVD-R Dual Layer (LJ)"
    DriveCaps(21).Value = 21
    DriveCaps(21).Feat = Feature.Write
    DriveCaps(22).Name = s_Writes & " " & "DVD-RAM"
    DriveCaps(22).Value = 22
    DriveCaps(22).Feat = Feature.Write
    DriveCaps(23).Name = s_Writes & " " & "DVD+RW"
    DriveCaps(23).Value = 23
    DriveCaps(23).Feat = Feature.Write
    DriveCaps(24).Name = s_Writes & " " & "DVD+R"
    DriveCaps(24).Value = 24
    DriveCaps(24).Feat = Feature.Write
    DriveCaps(25).Name = s_Writes & " " & "DVD+R Dual Layer"
    DriveCaps(25).Value = 25
    DriveCaps(25).Feat = Feature.Write
    DriveCaps(26).Name = s_Writes & " " & "Blu-Ray (BD-R)"
    DriveCaps(26).Value = 26
    DriveCaps(26).Feat = Feature.Write
    DriveCaps(27).Name = s_Writes & " " & "Blu-Ray (BD-RE)"
    DriveCaps(27).Value = 27
    DriveCaps(27).Feat = Feature.Write
    DriveCaps(28).Name = s_Writes & " " & "HD DVD-ROM"
    DriveCaps(28).Value = 28
    DriveCaps(28).Feat = Feature.Write
    DriveCaps(29).Name = s_Writes & " " & "HD DVD-RAM"
    DriveCaps(29).Value = 29
    DriveCaps(29).Feat = Feature.Write
    DriveCaps(30).Name = RM.GetString("Write Simulation")
    DriveCaps(30).Value = 30
    DriveCaps(30).Feat = Feature.Write
    DriveCaps(57).Name = RM.GetString("Supports Buffer Underrun Protection")
    DriveCaps(57).Value = 57
    DriveCaps(57).Feat = Feature.Write
    DriveCaps(58).Name = s_Writes & " " & "Mode DAO"
    DriveCaps(58).Value = 58
    DriveCaps(58).Feat = Feature.Write
    DriveCaps(59).Name = s_Writes & " " & "Mode DAO 96 Packet Write"
    DriveCaps(59).Value = 59
    DriveCaps(59).Feat = Feature.Write
    DriveCaps(60).Name = s_Writes & " " & "Mode DAO 96 Raw Write"
    DriveCaps(60).Value = 60
    DriveCaps(60).Feat = Feature.Write
    DriveCaps(61).Name = s_Writes & " " & "Mode DAO 16"
    DriveCaps(61).Value = 61
    DriveCaps(61).Feat = Feature.Write
    DriveCaps(62).Name = s_Writes & " " & "Mode RAW DAO"
    DriveCaps(62).Value = 62
    DriveCaps(62).Feat = Feature.Write
    DriveCaps(63).Name = s_Writes & " " & "Mode DAO CD Text"
    DriveCaps(63).Value = 63
    DriveCaps(63).Feat = Feature.Write
    DriveCaps(64).Name = s_Writes & " " & "Mode SAO"
    DriveCaps(64).Value = 64
    DriveCaps(64).Feat = Feature.Write
    DriveCaps(65).Name = s_Writes & " " & "Mode TAO"
    DriveCaps(65).Value = 65
    DriveCaps(65).Feat = Feature.Write
    DriveCaps(66).Name = s_Writes & " " & "Mode Packet Write"
    DriveCaps(66).Value = 66
    DriveCaps(66).Feat = Feature.Write
    DriveCaps(67).Name = s_Writes & " " & "CD Text"
    DriveCaps(67).Value = 67
    DriveCaps(67).Feat = Feature.Write

    'Misc features
    DriveCaps(41).Name = RM.GetString("Supports C2 Pointers")
    DriveCaps(41).Value = 41
    DriveCaps(41).Feat = Feature.Misc
    DriveCaps(42).Name = RM.GetString("Plays Audio")
    DriveCaps(42).Value = 42
    DriveCaps(42).Feat = Feature.Misc
    DriveCaps(43).Name = RM.GetString("Delivers Composite")
    DriveCaps(43).Value = 43
    DriveCaps(43).Feat = Feature.Misc
    DriveCaps(44).Name = RM.GetString("Supports Digital Port 1")
    DriveCaps(44).Value = 44
    DriveCaps(44).Feat = Feature.Misc
    DriveCaps(45).Name = RM.GetString("Supports Digital Port 2")
    DriveCaps(45).Value = 45
    DriveCaps(45).Feat = Feature.Misc
    DriveCaps(46).Name = RM.GetString("Uses CDDA Cmd")
    DriveCaps(46).Value = 46
    DriveCaps(46).Feat = Feature.Misc
    DriveCaps(47).Name = RM.GetString("Accurate CDDA")
    DriveCaps(47).Value = 47
    DriveCaps(47).Feat = Feature.Misc
    DriveCaps(48).Name = RM.GetString("Lock Supported")
    DriveCaps(48).Value = 48
    DriveCaps(48).Feat = Feature.Misc
    DriveCaps(49).Name = RM.GetString("Lock State")
    DriveCaps(49).Value = 49
    DriveCaps(49).Feat = Feature.Misc
    DriveCaps(50).Name = RM.GetString("Prevent Allow Jumper")
    DriveCaps(50).Value = 50
    DriveCaps(50).Feat = Feature.Misc
    DriveCaps(51).Name = RM.GetString("Eject Supported")
    DriveCaps(51).Value = 51
    DriveCaps(51).Feat = Feature.Misc
    DriveCaps(52).Name = RM.GetString("Supports Seprate Volume")
    DriveCaps(52).Value = 52
    DriveCaps(52).Feat = Feature.Misc
    DriveCaps(53).Name = RM.GetString("Supports Mute Seperate")
    DriveCaps(53).Value = 53
    DriveCaps(53).Feat = Feature.Misc
    DriveCaps(54).Name = RM.GetString("Supports DiscPresent")
    DriveCaps(54).Value = 54
    DriveCaps(54).Feat = Feature.Misc
    DriveCaps(55).Name = RM.GetString("SW Slot Select")
    DriveCaps(55).Value = 55
    DriveCaps(55).Feat = Feature.Misc
    DriveCaps(56).Name = RM.GetString("Supports Side Change")
    DriveCaps(56).Value = 56
    DriveCaps(56).Feat = Feature.Misc
  End Sub


  Public Sub BuildTree()
    tvwRecInfo.Nodes.Clear()

    ' if no drive selected, no drive info available
    If oDevice Is Nothing Then Exit Sub

    'Root
    Dim tmpnode As TreeNode
    tmpnode = tvwRecInfo.Nodes.Add(RM.GetString("Vendor:") & " " & oDevice.GetVendor())
    tmpnode.ImageIndex = 1
    tmpnode.SelectedImageIndex = 1
    tmpnode = tvwRecInfo.Nodes.Add(RM.GetString("Model:") & " " & oDevice.GetModel())
    tmpnode.ImageIndex = 1
    tmpnode.SelectedImageIndex = 1
    tmpnode = tvwRecInfo.Nodes.Add(RM.GetString("Firmware Version:") & " " & oDevice.GetFirmwareVersion())
    tmpnode.ImageIndex = 1
    tmpnode.SelectedImageIndex = 1
    tmpnode = tvwRecInfo.Nodes.Add(CStr(RM.GetString("Max Burn Speed:") & " " & IIf(oDevice.GetMaxWriteSpeed > 0, oDevice.GetMaxWriteSpeed.ToString & " KB/s", "Not reported")))
    tmpnode.ImageIndex = 1
    tmpnode.SelectedImageIndex = 1
    tmpnode = tvwRecInfo.Nodes.Add(CStr(RM.GetString("Max Read Speed:") & " " & IIf(oDevice.GetMaxReadSpeed > 0, oDevice.GetMaxReadSpeed.ToString & " KB/s", "Not reported")))
    tmpnode.ImageIndex = 1
    tmpnode.SelectedImageIndex = 1
    tmpnode = tvwRecInfo.Nodes.Add(RM.GetString("Buffer Size:") & " " & (oDevice.GetCacheSize() / 1024) & " MB")
    tmpnode.ImageIndex = 1
    tmpnode.SelectedImageIndex = 1

    Dim i As Integer = 0
    Dim readnode As New TreeNode
    Dim writenode As New TreeNode
    Dim miscnode As New TreeNode

    readnode.Text = RM.GetString("Supported Read Features")
    readnode.ImageIndex = 4
    readnode.SelectedImageIndex = 4
    tvwRecInfo.Nodes.Add(readnode)

    writenode.Text = RM.GetString("Supported Write Features")
    writenode.ImageIndex = 5
    writenode.SelectedImageIndex = 5
    tvwRecInfo.Nodes.Add(writenode)

    miscnode.Text = RM.GetString("Misc Features")
    miscnode.ImageIndex = 6
    miscnode.SelectedImageIndex = 6
    tvwRecInfo.Nodes.Add(miscnode)

    'Get the reading features
    For i = 0 To DriveCaps.Length - 1
      Dim isSupported As Boolean = oDevice.IsFeatureSupported(CType(DriveCaps(i).Value, NMSDVDXLib.eFeatureX))

      Select Case DriveCaps(i).Feat
        Case Feature.Read
          tmpnode = readnode.Nodes.Add(CStr(DriveCaps(i).Name & IIf(isSupported, ": " & RM.GetString("Yes"), ": " & RM.GetString("No"))))
          tmpnode.ImageIndex = CInt(IIf(isSupported, 2, 3))
          tmpnode.SelectedImageIndex = tmpnode.ImageIndex
        Case Feature.Write
          tmpnode = writenode.Nodes.Add(CStr(DriveCaps(i).Name & IIf(isSupported, ": " & RM.GetString("Yes"), ": " & RM.GetString("No"))))
          tmpnode.ImageIndex = CInt(IIf(isSupported, 2, 3))
          tmpnode.SelectedImageIndex = tmpnode.ImageIndex
        Case Feature.Misc
          tmpnode = miscnode.Nodes.Add(CStr(DriveCaps(i).Name & IIf(isSupported, ": " & RM.GetString("Yes"), ": " & RM.GetString("No"))))
          tmpnode.ImageIndex = CInt(IIf(isSupported, 2, 3))
          tmpnode.SelectedImageIndex = tmpnode.ImageIndex
      End Select
    Next
    tvwRecInfo.ExpandAll()
    tvwRecInfo.Nodes(0).EnsureVisible()
  End Sub

  Private Sub cmdClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdClose.Click
    Me.Close()
  End Sub

  Private Sub mnuCopy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuCopy.Click
    If Not tvwRecInfo.SelectedNode Is Nothing Then
      SafeClipboard.SetData(tvwRecInfo.SelectedNode.Text, True)
    End If
  End Sub

  Private Sub mnuCopyAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuCopyAll.Click
    Dim allText As New StringBuilder

    AppendAllText(tvwRecInfo.Nodes, allText)
    SafeClipboard.SetData(allText.ToString(), True)
  End Sub

  Private Sub AppendAllText(ByVal nodes As TreeNodeCollection, ByVal allText As StringBuilder)
    For Each node As TreeNode In nodes
      allText.AppendLine(String.Empty.PadLeft(node.Level * 2, " "c) & node.Text)
      AppendAllText(node.Nodes, allText)
    Next
  End Sub

  Private Sub tvwRecInfo_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles tvwRecInfo.MouseDown
    Dim selected As TreeNode = tvwRecInfo.GetNodeAt(e.Location)
    If Not selected Is Nothing Then
      tvwRecInfo.SelectedNode = selected
    End If
  End Sub

  Private Sub cboDrive_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboDrive.SelectedIndexChanged
    oDevice = cboDrive.SelectedDevice
    BuildTree()
  End Sub

End Class
