using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using NMSDVDXLib;
using System.ComponentModel;

namespace CDBurnerXP.Controls
{
    public class DeviceSelectToolstip : ToolStripControlHost
    {
        public DeviceSelect DeviceSelect
        {
            get
            {
                return this.Control as DeviceSelect;
            }
        }

        public DeviceSelectToolstip()
            : base(new DeviceSelect())
        {
        }

        /// <summary>
        /// Gets or sets whether or not the StarBurn
        /// burning engine should be used.
        /// </summary>
        [DefaultValue(false)]
        public bool UseStarBurn
        {
            get { return this.DeviceSelect.UseStarBurn; }
            set { this.DeviceSelect.UseStarBurn = value; }
        }

        [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden),
        Browsable(false)]
        public override bool Enabled
        {
            get { return base.Enabled; }
            set { base.Enabled = value;  }
        }
    }
}
