using System;
using System.Collections.Generic;
using System.Text;

namespace CDBurnerXP.Controls
{
    public class ItemAddError
    {
        private string m_Path = null;
        private Exception m_Exception = null;
        private string m_Message = string.Empty;

        public string Path
        {
            get
            {
                return m_Path;
            }
        }

        public string Message
        {
            get {
                if (!string.IsNullOrEmpty(m_Message))
                {
                    return m_Message;
                }
                else if (m_Exception != null)
                {
                    return m_Exception.Message;
                }
                else
                {
                    return string.Empty;
                }
            }
        }

        public ItemAddError(string path, Exception ex)
        {
            m_Path = path;
            m_Exception = ex;
        }

        public ItemAddError(string path, string message)
        {
            m_Path = path;
            m_Message = message;
        }

        public override string ToString()
        {
            return m_Path + " (" + m_Exception.GetType().Name + ")";
        }
    }
}
