using System.Drawing;
using System;
using System.Windows.Forms;

namespace CDBurnerXP.Forms
{
    public class Win2kToolstripRenderer : ToolStripSystemRenderer
    {

        protected override void OnRenderToolStripBackground(System.Windows.Forms.ToolStripRenderEventArgs e)
        {
            // Windows 2000: 5.0
            if (Environment.OSVersion.Version.Major <= 5 & Environment.OSVersion.Version.Minor <= 0)
            {
                SolidBrush b = new SolidBrush(SystemColors.Control);
                e.Graphics.FillRectangle(b, e.AffectedBounds);
                b.Dispose();
            }
            else
            {
                try
                {
                    base.OnRenderToolStripBackground(e);
                }
                catch (ArgumentException)
                {
                    using (Brush b = new SolidBrush(SystemColors.Control))
                    {
                        e.Graphics.FillRectangle(b, e.ToolStrip.Bounds);
                    }
                }
            }
        }

        protected override void OnRenderToolStripPanelBackground(ToolStripPanelRenderEventArgs e)
        {
            try
            {
                base.OnRenderToolStripPanelBackground(e);
            }
            catch (ArgumentException)
            {
                using (Brush b = new SolidBrush(SystemColors.Control))
                {
                    e.Graphics.FillRectangle(b, e.ToolStripPanel.Bounds);
                    e.Handled = true;
                }
            }
        }
    }
}
