using System;
using System.Collections.Generic;
using System.Text;
using CDBurnerXP.Controls;

namespace CDBurnerXP.Printing
{
    public class CoverListItem
    {
        private string displayName = "";
        private string fullPath = "";
        private string additionalInfo = "";
        private AudioTrack track = null;

        #region Properties

        public AudioTrack Track
        {
            get { return this.track; }
        }

        public string DisplayName
        {
            get
            {
                return this.displayName;
            }
        }

        public string AdditionalInfo
        {
            get
            {
                return this.additionalInfo;
            }
        }

        public string FullPath
        {
            get { return this.fullPath; }
        }

        #endregion

        public CoverListItem(string displayName, string fullPath, string additionalInfo)
        {
            this.displayName = displayName;
            this.fullPath = fullPath;
            this.additionalInfo = additionalInfo;
        }

        public CoverListItem(AudioTrack track)
        {
            this.displayName = track.FileName;
            this.fullPath = track.FileName;
            if (track.Length.Hours > 0)
            {
                this.additionalInfo = string.Format("{2:00}:{0:00}:{1:00}", track.Length.Minutes, track.Length.Seconds, track.Length.Hours);
            }
            else
            {
                this.additionalInfo = string.Format("{0:00}:{1:00}", track.Length.Minutes, track.Length.Seconds);
            }

            this.track = track;
        }
    }
}
